
uniform float u_FactorR;
uniform float u_FactorG;
uniform float u_FactorB;
uniform float u_Night;

#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D CC_Texture0;

void main()
{
    vec4 v4TexColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);

    vec3 v3Color;
    v3Color.x = u_FactorR * v4TexColor.x;
    v3Color.y = u_FactorG * v4TexColor.y;
    v3Color.z = u_FactorB * v4TexColor.z;

    gl_FragColor.x = v3Color.x + (v4TexColor.x - v3Color.x) * (1.0 - u_Night);
    gl_FragColor.y = v3Color.y + (v4TexColor.y - v3Color.y) * (1.0 - u_Night);
    gl_FragColor.z = v3Color.z + (v4TexColor.z - v3Color.z) * (1.0 - u_Night);
    gl_FragColor.w = 1.0;
}
