attribute vec4 a_position;
attribute vec4 a_ParticleInfo0;


#ifdef GL_ES
varying lowp vec4 v_fragmentColor;
#else
varying vec4 v_fragmentColor;
#endif



uniform	vec4	u_vecBoxData;			/**		x : Box width	
												y : Box height
												z : x
												w : Total Elapsed time		*/


uniform	vec4	u_vecCameraData;		/**		x : Total Elapsed time	
												y : Emitter life time
												z : Emitter size
												w : Emitter Depth scale		*/


uniform	vec4	u_vecEffectData;		/**		x : Swing	
												y : Emitter life time
												z : Emitter size
												w : Gravity					*/

void main()
{
    // prepare -------------------------------------------------------------------------------------
	float	fEmitterLifeTime	=	u_vecEffectData.y;
	float	Gravity				=	u_vecEffectData.w;
    float	fSwing				=	a_ParticleInfo0.x;
	float	fSwingDir			=	a_ParticleInfo0.y;
	float	fSwingSpeed			=	u_vecEffectData.x;

	float	fElapsed			=	u_vecBoxData.w - a_position.w;	//	fTotalElapsedTime - EmitterStartTime;
    float	fDepthScale			=	a_position.z;

	vec4	v4Pos;
    v4Pos.x	=	a_position.x + sin(fSwingDir + fElapsed * fSwingSpeed) * fSwing;
    v4Pos.y	=	a_position.y + fElapsed * Gravity;
    v4Pos.z	=	0.0;
    v4Pos.w	=	1.0;

	v4Pos.xy	+=	u_vecCameraData.xy;

	vec2	vecWrap		=	u_vecBoxData.xy / fDepthScale;
	vec4	tempData	=	vec4( v4Pos.xy, u_vecBoxData.xy ) / vec4( vecWrap.xy, vecWrap.xy );
	 
	v4Pos.xy	-=	floor( tempData.xy ) * vecWrap;
    if (v4Pos.x < 0.0)
    {
        v4Pos.x += vecWrap.x;
    }
    if (v4Pos.y < 0.0)
    {
        v4Pos.y += vecWrap.y;
    }

	v4Pos.xy	*=	tempData.zw;
	
    float fAlpha = 1.0;
    if( fElapsed <= 1.0)
    {
        fAlpha	=	fElapsed;
    }
    fAlpha  =   max(0.0, min(fAlpha, min(1.0, fEmitterLifeTime - fElapsed)));
    fAlpha  *=  a_ParticleInfo0.w;
    
    gl_Position		=	CC_MVPMatrix * v4Pos;
	gl_PointSize	=	a_ParticleInfo0.z * u_vecCameraData.w;
    v_fragmentColor =	vec4(1.0, 1.0, 1.0, fAlpha);
}
